## MmmmTools   -  Usability Improvements For Maya
## Copyright (C) <2008>  Joseph Crawford
##
## This file is part of MmmmTools.
##
## MmmmTools is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## MmmmTools is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.
##
################################################
## More information is available:
## MmmmTools website - http://celestinestudios.com/mmmmtools
################################################
import traceback
from pymel.core import *
import maya.mel
import pymel.all as pm
import RendererProductionShadersMaker
import RendererLightsMultiplier

class Renderer(object):
    def __init__(self, parent):
        self.parent = parent
    
    """         
    def runSelector( self, makeUi=True ):
        reload( ModelerSelector )
        self.modelerMeshUtilitiesAndAlignerSelector = ModelerSelector.ModelerSelector( makeUi=makeUi )  
    def runAligner( self, makeUi=True ):
        reload( ModelerAligner )
        self.modelerAligner = ModelerAligner.ModelerAligner( makeUi=makeUi )"""    

    def reflectivityOfSelectedMaterialsToZero(self):
        objs = pm.ls(selection=True)
        for obj in objs:
            try:
                obj.reflectivity.set(0)
            except:
                print( "Could not set reflectivity for node: " + obj.name()  )
                traceback.print_exc()

    

    def runProductionShadersMaker(self):
        try:
            reload( RendererProductionShadersMaker )
        except:
            import RendererProductionShadersMaker
        self.productionShadersMaker = RendererProductionShadersMaker.RendererProductionShadersMaker( makeUi=True )
        
    def runLightsMultiplier(self):
        try:
            reload( RendererLightsMultiplier )
        except:
            import RendererLightsMultiplier
        self.lightsMultiplier = RendererLightsMultiplier.RendererLightsMultiplier( makeUi=True )
        
        
        
        RendererLightsMultiplier
