import pymel.all as pm

class Selector(object):
    def __init__(self, parentRef):
        self.parent = parentRef
        self.mmmm = self.parent
        self.slots = {}
        self.quickList = []
        self.activeSlot = 0

    def printActiveSlot(self):
        self.mmmm.u.printWarning( "Selector active slot is now: " + str(self.activeSlot)  )
        
    def nextSlot( self ):
        self.activeSlot = int(self.activeSlot) + 1
        self.printActiveSlot()

    def prevSlot( self ):
        self.activeSlot = int(self.activeSlot) - 1
        self.printActiveSlot()
         
    def getSlots(self, slotsCount=2, useStartSlot=False, startSlot=None):
        if useStartSlot:
            if startSlot is None:
                startSlot = self.activeSlot        
            else:
                sslot = startSlot
        else:
            sslot = 0
            
        #n=int(n)
        result = []
        for i in xrange(slotsCount):
            result.append( self.slots[i + sslot] )
                ## this should fail if we
                ## don't have enough slots
                ## in that case we want an
                ## exception
        return result
        
    def getSlot(self, n=None):
        if n is None:
            n = int( self.activeSlot )
        else:
            n = 0
            
        n=int(n)
        return self.slots[n]
    
    def nFixDefault(self,n):
        if n is None:
            n = int( self.activeSlot )
        else:
            n = 0        
        return n

        
    def setSlot(self, n=None, listToSet=None):
        n = self.nFixDefault(n)
                    
        n = int(n)
        if isinstance(listToSet, list ):
            l = listToSet
        else:
            l = pm.ls(selection=True)
        self.slots[n] = l
        
    def selSlot( self, n=None, add=False ):
        n = self.nFixDefault(n)
        l = self.slots[n]
        self.selList( l, add=add )
        
    def selList( self, l, add=False ):
        print( "sel list function:" )
        print( l )
        print( type(l) )
        try:
            pm.select( l , add=add )
        except:
            if add==False:
                pm.select(clear=True)
            for obj in l:
                try:
                    pm.select( obj, add=True )
                except:
                    self.mmmm.u.printWarning( "Could not select a node, most likely an"
                          " object that was in the selection slot has been deleted."
                    )
                
    def setNamedSlot( self, name, listToUse=None ):
        if listToUse is None:
            listToUse = pm.ls(selection=True)
        self.slots[name] = listToUse
    
    def selNamedSlot( self, name ):
        self.selList( self.slots[name] )
        
    def setNamedSlotByUi(self):
        name = self.mmmm.prompt( 'Set/Save selection to a named slot.  Enter the name of the slot to use:', )
        if not name is None:
            name = unicode( name )
            self.setNamedSlot( name )
        
    def selNamedSlotByUi(self):
        name = self.mmmm.prompt( 'Select nodes stored in named slot.  Enter the name of the slot to use:', )
        if not name is None:
            name = unicode( name )
            self.selNamedSlot( name )
            
    def showSlotsUi( self, maxToShow=10 ):
        m = []
        
        m.append( "The following named slots are being used:" )
        m.append( "\n\n\n" )
        keys = self.slots.keys()
        if len(keys) < maxToShow:
            for k in self.slots.keys():
                if isinstance( k, basestring ):
                    m.append( k )
            msg = "\n".join( m )
        else:
            msg = "Please see the script editor \n " \
            " history for a printout of \n" \
            " named slots, since it is \n" \
            " too long to show here."
        request = self.mmmm.prompt( msg=msg )
        print( msg )
        self.selNamedSlot( unicode(request) )
        
    
    #def createSet(self, name=None):
      #  
     #   "MmmmSelectorSet"

    
    
pass